param (
    [switch]$ShowFiles = $false
)


$reservedDirs = @(
    'servers'
    '.skel'
    'fs'
    'sitebuilder'
    'webmail'
)

$searchMask = @(
    '*.pl'
    '*.py'
)

$ignoredFiles = @(
    'test.pl'
    'test.py'
)

[string[]]$affectedDomains = @() 
[string[]]$affectedFiles = @() 

Get-ChildItem -Path $env:plesk_vhosts | ForEach-Object -Process {
    if ($reservedDirs -icontains $_.Name) {
        return
    }

    $processedDomains++
    Write-Progress "Processing $_ ..."
    $files = Get-ChildItem -Path $_.FullName -Recurse -Include $searchMask | Where-Object -FilterScript { ($_.FullName -inotmatch 'webstat\\AWStats') -and ($ignoredFiles -inotcontains $_.Name)}

    if ($files.Length -gt 0) {
        $affectedDomains += $_.Name
        $files | ForEach-Object -Process { $affectedFiles += $_.FullName }
    }
}

if ($ShowFiles) {
    Return $affectedFiles
} else {
    if ($affectedDomains.Length -gt 0) {
        Write-Host "Perl and Python files were found inside" $affectedDomains.Length "subscriptions."
        Write-Host "Launch the same script with parameter -ShowFiles to get exact list of files."
        Write-Host "Subscriptions:"
        Write-Host $affectedDomains
    } else {
        Write-Host "No Perl and Python files found inside Plesk subscriptions."
    }
}